import router from './router'
import store from './store'
import NProgress from 'nprogress' // progress bar
import 'nprogress/nprogress.css' // progress bar style
// import { getToken } from '@/utils/auth' // get token from cookie

NProgress.configure({ showSpinner: false }) // NProgress Configuration

const whiteList = ['/login', '/resetpassword', '/help', '/echarts'] // no redirect whitelist

// eslint-disable-next-line prettier/prettier
router.beforeEach(async(to, from, next) => {
  // start progress bar
  NProgress.start()
  // set page title

  // determine whether the user has logged in
  // const hasToken = getToken()
  const hasToken = store.getters.id

  if (to.query.courseid !== '' && to.query.courseid !== undefined) {
    console.log(to.query.courseid)
    await store.commit('SET_COURSEID', to.query.courseid)
  }
  if (to.query.testid !== '' && to.query.testid !== undefined) {
    await store.commit('SET_TESTID', to.query.testid)
  }
  const shareCourseId =
    window.location.href.indexOf('?shareCourseId=') != -1
      ? window.location.href.split('?shareCourseId=')[1].toString()
      : ''
  if (shareCourseId) {
    await store.commit('SET_SHARECOURSEID', shareCourseId)
  }
  if (hasToken) {
    if (to.path === '/login') {
      // if is logged in, redirect to the home page

      next({ path: '/' })
      NProgress.done()
    } else {
      const userinfo = store.getters.userinfo && Object.keys(store.getters.userinfo).length > 0
      console.log('store.getters', store.getters)
      console.log('userinfo', userinfo)
      // console.log('to', {...to} )
      if (userinfo) {
        next()
      } else {
        try {
          // 获取用户信息
          const data = await store.dispatch('user/getInfo')
          await store.commit('user/SET_USERINFO', data)
          const courseId = store.getters.courseId
          const testId = store.getters.testId
          const shareCourseId = store.getters.shareCourseId
          await store.commit('SET_TESTID', '')
          await store.commit('SET_COURSEID', '')
          await store.commit('SET_SHARECOURSEID', '')
          // // 根据角色生成可访问的路线图
          if (courseId) {
            next({ ...to, query: { courseid: courseId }, replace: true })
          } else if (testId) {
            next({ ...to, query: { courseid: testId }, replace: true })
          } else if (shareCourseId) {
            next({ path: '/courseDetail', query: { courseid: shareCourseId, urlType: 1 }, replace: true })
          } else {
            next({ ...to, replace: true })
          }
        } catch (error) {
          // remove token and go to login page to re-login
          // await store.dispatch('user/resetToken')
          // Notify({ type: 'danger', message: error || '发生异常' })
          next(`/login?redirect=${to.path}`)
          NProgress.done()
        }
      }
    }
  } else {
    // next()
    /* has no token*/
    if (whiteList.indexOf(to.path) !== -1) {
      // in the free login whitelist, go directly
      next()
    } else {
      //   // other pages that do not have permission to access are redirected to the login page.
      next(`/login?redirect=${to.path}`)
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
